// $Header: $
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.
// ReadMultipleItemsXml.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"	// Includes "QuickOpc.h", and other commonly used files
#include <time.h>       /* time_t, time, ctime */
#include <string>

//
const std::string currentDateTime() {
	time_t     now = time(0);
	struct tm  tstruct;
	char       buf[80];
	tstruct = *localtime(&now);
	strftime(buf, sizeof(buf), "%Y-%m-%d.%X", &tstruct);

	return buf;
}

int _tmain(int argc, _TCHAR* argv[])
{
    // Initialize the COM library. Note: If you choose STA, you will be responsible for pumping messages.
    CoInitializeEx(NULL, COINIT_MULTITHREADED);

    // Instatiate the EasyOPC-DA client object
    _EasyDAClientPtr ClientPtr(__uuidof(EasyDAClient));

	for (int x = 0; x < 100; x++)
	{

		_DAReadItemArgumentsPtr ReadItemArguments1Ptr(_uuidof(DAReadItemArguments));
		ReadItemArguments1Ptr->ServerDescriptor->UrlString = L"http://opcxml.demo-this.com/XmlDaSampleServer/Service.asmx";
		ReadItemArguments1Ptr->ItemDescriptor->ItemId = L"Dynamic/Analog Types/Double";

		_DAReadItemArgumentsPtr ReadItemArguments2Ptr(_uuidof(DAReadItemArguments));
		ReadItemArguments2Ptr->ServerDescriptor->UrlString = L"http://opcxml.demo-this.com/XmlDaSampleServer/Service.asmx";
		ReadItemArguments2Ptr->ItemDescriptor->ItemId = L"Dynamic/Analog Types/Double[]";

		_DAReadItemArgumentsPtr ReadItemArguments3Ptr(_uuidof(DAReadItemArguments));
		ReadItemArguments3Ptr->ServerDescriptor->UrlString = L"http://opcxml.demo-this.com/XmlDaSampleServer/Service.asmx";
		ReadItemArguments3Ptr->ItemDescriptor->ItemId = L"Dynamic/Analog Types/Int";

		_DAReadItemArgumentsPtr ReadItemArguments4Ptr(_uuidof(DAReadItemArguments));
		ReadItemArguments4Ptr->ServerDescriptor->UrlString = L"http://opcxml.demo-this.com/XmlDaSampleServer/Service.asmx";
		ReadItemArguments4Ptr->ItemDescriptor->ItemId = L"Dynamic/Analog Types/Int[]";

		_DAReadItemArgumentsPtr ReadItemArguments5Ptr(_uuidof(DAReadItemArguments));
		ReadItemArguments5Ptr->ServerDescriptor->UrlString = L"http://opcxml.demo-this.com/XmlDaSampleServer/Service.asmx";
		ReadItemArguments5Ptr->ItemDescriptor->ItemId = L"SomeUnknownItem";

		CComSafeArray<VARIANT> ArgumentsArray(5);
		ArgumentsArray.SetAt(0, _variant_t((IDispatch*)ReadItemArguments1Ptr));
		ArgumentsArray.SetAt(1, _variant_t((IDispatch*)ReadItemArguments2Ptr));
		ArgumentsArray.SetAt(2, _variant_t((IDispatch*)ReadItemArguments3Ptr));
		ArgumentsArray.SetAt(3, _variant_t((IDispatch*)ReadItemArguments4Ptr));
		ArgumentsArray.SetAt(4, _variant_t((IDispatch*)ReadItemArguments5Ptr));

		LPSAFEARRAY pArgumentsArray = ArgumentsArray.Detach();
		CComSafeArray<VARIANT> ResultArray;

		printf("%s Before ReadMultipleItems.\n", currentDateTime().c_str());

		ResultArray.Attach(ClientPtr->ReadMultipleItems(&pArgumentsArray));

		printf("%s After ReadMultipleItems.\n", currentDateTime().c_str());

		ArgumentsArray.Attach(pArgumentsArray);

		for (int i = ResultArray.GetLowerBound(0); i <= ResultArray.GetUpperBound(0); i++)
		{
			_DAVtqResultPtr DAVtqResultPtr(ResultArray[i]);

			_ExceptionPtr ExceptionPtr(DAVtqResultPtr->Exception);
			if (ExceptionPtr != NULL)
			{
				_variant_t exceptionAsString(ExceptionPtr->ToString);
				_tprintf(_T("results(%d).Exception.ToString(): %s\n"), i, exceptionAsString.bstrVal);
				continue;
			}

			_DAVtqPtr DAVtqPtr(DAVtqResultPtr->Vtq);
			_variant_t vtqAsString(DAVtqPtr->ToString);
			_tprintf(_T("results(%d).Vtq.ToString(): %s\n"), i, vtqAsString.bstrVal);
		}

		// Release all interface pointers BEFORE calling CoUninitialize()
		ResultArray.Destroy();
		Sleep(1000);
	}
    ClientPtr = NULL;

    CoUninitialize();

    TCHAR line[80];
    _putts(_T("Press Enter to continue..."));
    _fgetts(line, sizeof(line), stdin);
    return 0;
}

